import { tryHead as tryHead_1, choose, cons, empty, collect, singleton, ofSeq, ofArray as ofArray_1, map as map_3 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/List.js";
import { makeUnion, makeRecord, parseEnum, bool_type, string_type, getUnionCaseFields, getUnionFields, getTupleField, getRecordField, getEnumName, record_type, list_type, name } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Reflection.js";
import { createTypeInfo } from "../test/.fable/Fable.SimpleJson.3.16.2/TypeInfo.Converter.fs.js";
import { toSeq, iterate, FSharpMap__TryFind, ofArray as ofArray_2, ofSeq as ofSeq_1, map as map_5, ofList } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Map.js";
import { FSharpRef, Record } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Types.js";
import { CustomRuleModule_buidInRules, CustomRule$reflection } from "./CustomRule.fs.js";
import { Json } from "../test/.fable/Fable.SimpleJson.3.16.2/Json.fs.js";
import { mapIndexed, map as map_4 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Array.js";
import { tryHead, head, rangeNumber, delay, map as map_6, ofArray } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Seq.js";
import { toFail, printf, toText, join } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/String.js";
import { Convert_removeQuotes, Convert_quoteText } from "../test/.fable/Fable.SimpleJson.3.16.2/Json.Converter.fs.js";
import { SchemaModule_Annotator__Field, SchemaModule_Annotator__Record_Z721C83C5, SchemaModule_stub, SchemaModule_Annotator__Enum_Z721C83C5, SchemaModule_Annotator_$ctor_Z721C83C5, SchemaModule_nameFromTypeInfo, SchemaModule_nameFromType } from "./Schema.fs.js";
import { defaultArg, map as map_7, defaultArgWith, some, bind, value as value_34 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Option.js";
import { parse as parse_2, toString } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Date.js";
import { parse as parse_4, fromInt32, toString as toString_1 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/BigInt.js";
import { Dictionary } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/MutableMap.js";
import { compare, structuralHash, equalArrays } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Util.js";
import { fromNumber } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Long.js";
import { ofList as ofList_1 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Set.js";
import { tryGetValue, addToDict } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/MapUtil.js";
import Decimal from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Decimal.js";
import { parse as parse_1 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Guid.js";
import { parse as parse_3 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/DateOffset.js";

export function rulesMap(rules) {
    let elements;
    elements = map_3((rule) => {
        let SurrogateTypeInfo;
        return [name(rule.InstanceType), (SurrogateTypeInfo = createTypeInfo(rule.SurrogateType), {
            CastFromSurrogate: rule.CastFromSurrogate,
            CastToSurrogate: rule.CastToSurrogate,
            SurrogateTypeInfo: SurrogateTypeInfo,
        })];
    }, rules);
    return ofList(elements);
}

export class SerializationOptions extends Record {
    constructor(CustomRules) {
        super();
        this.CustomRules = CustomRules;
    }
}

export function SerializationOptions$reflection() {
    return record_type("Fable.Avro.JsonSerde.SerializationOptions", [], SerializationOptions, () => [["CustomRules", list_type(CustomRule$reflection())]]);
}

export const defaultSerializationOptions = new SerializationOptions(CustomRuleModule_buidInRules);

export function createSerializer$0027(type$0027, options) {
    const ti = createTypeInfo(type$0027);
    let rulesMap_1;
    rulesMap_1 = rulesMap(options.CustomRules);
    return (value) => {
        const parse = (value_1) => ((ti_1) => {
            let array_1, source_1, list, source_2, list_1, source_3, source_4;
            switch (ti_1.tag) {
                case 0: {
                    return new Json(3);
                }
                case 1: {
                    return new Json(1, value_1);
                }
                case 6: {
                    return new Json(2, value_1);
                }
                case 12:
                case 10:
                case 2:
                case 5:
                case 3:
                case 11:
                case 4:
                case 7:
                case 8: {
                    let arg0;
                    arg0 = value_1;
                    return new Json(0, arg0);
                }
                case 32: {
                    const patternInput = ti_1.fields[0]();
                    const arg0_1 = getEnumName(patternInput[1], value_1);
                    return new Json(1, arg0_1);
                }
                case 22: {
                    return parseArray(ti_1.fields[0]())((value_1));
                }
                case 24: {
                    const matchValue = ti_1.fields[0]();
                    if (matchValue.tag === 12) {
                        let arg0_2;
                        let input;
                        let inputText;
                        let strings;
                        let source;
                        source = map_4((x) => (String.fromCharCode(x)), value_1);
                        strings = ofArray(source);
                        inputText = join("", strings);
                        input = Convert_quoteText(inputText);
                        arg0_2 = Convert_removeQuotes(input);
                        return new Json(1, arg0_2);
                    }
                    else {
                        return parseArray(matchValue)((array_1 = (value_1), (ofArray_1(array_1))));
                    }
                }
                case 29: {
                    return parseArray(ti_1.fields[0]())((source_1 = (value_1), (ofSeq(source_1))));
                }
                case 23: {
                    return parseArray(ti_1.fields[0]())((list = (source_2 = (value_1), (ofSeq(source_2))), (map_3((value_7) => value_7, list))));
                }
                case 30: {
                    return parseArray(ti_1.fields[0]())((list_1 = (source_3 = (value_1), (ofSeq(source_3))), (map_3((value_9) => value_9, list_1))));
                }
                case 25: {
                    return parseArray(ti_1.fields[0]())((source_4 = (value_1), (ofSeq(source_4))));
                }
                case 27: {
                    const patternInput_1 = ti_1.fields[0]();
                    let arg0_3;
                    let table;
                    table = value_1;
                    arg0_3 = map_5((_arg1, value_12) => parse(value_12)(patternInput_1[1]), table);
                    return new Json(5, arg0_3);
                }
                case 28: {
                    const patternInput_2 = ti_1.fields[0]();
                    let arg0_4;
                    let elements;
                    let source_5;
                    source_5 = value_1;
                    elements = map_6((pair) => [pair[0], parse(pair[1])(patternInput_2[1])], source_5);
                    arg0_4 = ofSeq_1(elements);
                    return new Json(5, arg0_4);
                }
                case 33: {
                    const patternInput_3 = ti_1.fields[0]();
                    let arg0_5;
                    let elements_1;
                    elements_1 = map_4((field) => {
                        const fieldValue = getRecordField(value_1, field.PropertyInfo);
                        return [field.FieldName, parse(fieldValue)(field.FieldType)];
                    }, patternInput_3[0]);
                    arg0_5 = ofArray_2(elements_1);
                    return new Json(5, arg0_5);
                }
                case 26: {
                    let arg0_6;
                    let elements_2;
                    const array_3 = ti_1.fields[0]();
                    elements_2 = mapIndexed((idx, itemTypeInfo) => {
                        let arg10, clo1;
                        const itemValue = getTupleField(value_1, idx);
                        return [(arg10 = ((idx + 1) | 0), (clo1 = toText(printf("Item%d")), clo1(arg10))), parse(itemValue)(itemTypeInfo)];
                    }, array_3);
                    arg0_6 = ofArray_2(elements_2);
                    return new Json(5, arg0_6);
                }
                case 34: {
                    const patternInput_4 = ti_1.fields[0]();
                    const unionType = patternInput_4[1];
                    const patternInput_5 = getUnionFields(value_1, unionType);
                    const usedCaseInfo = patternInput_5[0];
                    let usedCase;
                    usedCase = patternInput_4[0].find((case$) => (case$.CaseName === name(usedCaseInfo)));
                    let caseRecord;
                    let arg0_7;
                    let elements_3;
                    const array_5 = getUnionCaseFields(usedCaseInfo);
                    elements_3 = mapIndexed((idx_1, pi) => [name(pi), parse(patternInput_5[1][idx_1])(usedCase.CaseTypes[idx_1])], array_5);
                    arg0_7 = ofArray_2(elements_3);
                    caseRecord = (new Json(5, arg0_7));
                    let arg0_8;
                    const elements_4 = singleton([(SchemaModule_nameFromType(unionType) + ".") + name(usedCaseInfo), caseRecord]);
                    arg0_8 = ofList(elements_4);
                    return new Json(5, arg0_8);
                }
                case 21: {
                    const matchValue_1 = value_1;
                    if (matchValue_1 != null) {
                        const v = value_34(matchValue_1);
                        const typeInfo = ti_1.fields[0]();
                        let arg0_9;
                        const elements_5 = singleton([SchemaModule_nameFromTypeInfo(typeInfo), parse(v)(typeInfo)]);
                        arg0_9 = ofList(elements_5);
                        return new Json(5, arg0_9);
                    }
                    else {
                        return new Json(3);
                    }
                }
                case 9: {
                    return new Json(0, value_1);
                }
                case 17: {
                    let arg0_11;
                    let copyOfStruct = value_1;
                    arg0_11 = copyOfStruct;
                    return new Json(1, arg0_11);
                }
                case 13: {
                    let arg0_12;
                    let copyOfStruct_1 = value_1;
                    arg0_12 = toString(copyOfStruct_1, "O", {});
                    return new Json(1, arg0_12);
                }
                case 14: {
                    let arg0_13;
                    let copyOfStruct_2 = value_1;
                    arg0_13 = toString(copyOfStruct_2, "O", {});
                    return new Json(1, arg0_13);
                }
                case 16: {
                    let arg0_14;
                    arg0_14 = value_1;
                    return new Json(0, arg0_14);
                }
                case 15: {
                    let arg0_15;
                    arg0_15 = toString_1(value_1);
                    return new Json(1, arg0_15);
                }
                case 18: {
                    const type$0027_2 = ti_1.fields[0]();
                    const matchValue_2 = FSharpMap__TryFind(rulesMap_1, name(type$0027_2));
                    if (matchValue_2 != null) {
                        const rule = matchValue_2;
                        return parse(rule.CastToSurrogate(value_1))(rule.SurrogateTypeInfo);
                    }
                    else {
                        const clo1_1 = toFail(printf("Serialization of the type is not supported: %A"));
                        return clo1_1(type$0027_2);
                    }
                }
                default: {
                    const clo1_2 = toFail(printf("Serialization of the type is not supported: %A"));
                    return clo1_2(ti_1);
                }
            }
        });
        const parseArray = (elTypeInfo) => ((elements_6) => {
            let arg0_16;
            arg0_16 = map_3((el) => parse(el)(elTypeInfo), elements_6);
            return new Json(4, arg0_16);
        });
        return parse(value)(ti);
    };
}

export class DeserializationOptions extends Record {
    constructor(CustomRules, Annotations, EvolutionTolerantMode) {
        super();
        this.CustomRules = CustomRules;
        this.Annotations = Annotations;
        this.EvolutionTolerantMode = EvolutionTolerantMode;
    }
}

export function DeserializationOptions$reflection() {
    return record_type("Fable.Avro.JsonSerde.DeserializationOptions", [], DeserializationOptions, () => [["CustomRules", list_type(CustomRule$reflection())], ["Annotations", string_type], ["EvolutionTolerantMode", bool_type]]);
}

export const defaultDeserializationOptions = new DeserializationOptions(CustomRuleModule_buidInRules, "", true);

export function createDeserializer$0027(type$0027, options) {
    const ti = createTypeInfo(type$0027);
    let rulesMap_1;
    rulesMap_1 = rulesMap(options.CustomRules);
    const ann = SchemaModule_Annotator_$ctor_Z721C83C5(options.Annotations);
    const defValues = new Dictionary([], {
        Equals: equalArrays,
        GetHashCode: structuralHash,
    });
    const casesCache = new Map([]);
    return (json) => {
        const parse = (ti_1) => ((json_1) => {
            const matchValue_1 = [json_1, ti_1];
            let pattern_matching_result, v_1, v_2, v_3, v_4, v_5, v_6, v_7, v_8, v_9, v_10, v_11, f, v_12, f_1, v_13, elements_1, f_2, elements_2, f_3, elements_3, f_4, elements_4, f_5, elements_6, f_6, elements_7, f_7, f_8, props, f_9, props_1, f_10, props_2, f_11, props_3, f_12, props_4, f_14, props_6, v_15, v_16, v_17, v_18, v_19, v_20, v_21, v_22, f_15, json_3, wrong_1;
            if (matchValue_1[0].tag === 2) {
                if (matchValue_1[1].tag === 6) {
                    pattern_matching_result = 1;
                    v_2 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 18) {
                    pattern_matching_result = 34;
                    f_15 = matchValue_1[1].fields[0];
                    json_3 = matchValue_1[0];
                }
                else {
                    pattern_matching_result = 35;
                    wrong_1 = matchValue_1;
                }
            }
            else if (matchValue_1[0].tag === 0) {
                if (matchValue_1[1].tag === 12) {
                    pattern_matching_result = 2;
                    v_3 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 10) {
                    pattern_matching_result = 3;
                    v_4 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 2) {
                    pattern_matching_result = 4;
                    v_5 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 5) {
                    pattern_matching_result = 5;
                    v_6 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 3) {
                    pattern_matching_result = 6;
                    v_7 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 11) {
                    pattern_matching_result = 7;
                    v_8 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 4) {
                    pattern_matching_result = 8;
                    v_9 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 7) {
                    pattern_matching_result = 9;
                    v_10 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 8) {
                    pattern_matching_result = 10;
                    v_11 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 9) {
                    pattern_matching_result = 26;
                    v_15 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 16) {
                    pattern_matching_result = 31;
                    v_20 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 15) {
                    pattern_matching_result = 32;
                    v_21 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 18) {
                    pattern_matching_result = 34;
                    f_15 = matchValue_1[1].fields[0];
                    json_3 = matchValue_1[0];
                }
                else {
                    pattern_matching_result = 35;
                    wrong_1 = matchValue_1;
                }
            }
            else if (matchValue_1[0].tag === 4) {
                if (matchValue_1[1].tag === 22) {
                    pattern_matching_result = 13;
                    elements_1 = matchValue_1[0].fields[0];
                    f_2 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 24) {
                    pattern_matching_result = 14;
                    elements_2 = matchValue_1[0].fields[0];
                    f_3 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 29) {
                    pattern_matching_result = 15;
                    elements_3 = matchValue_1[0].fields[0];
                    f_4 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 23) {
                    pattern_matching_result = 16;
                    elements_4 = matchValue_1[0].fields[0];
                    f_5 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 30) {
                    pattern_matching_result = 17;
                    elements_6 = matchValue_1[0].fields[0];
                    f_6 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 25) {
                    pattern_matching_result = 18;
                    elements_7 = matchValue_1[0].fields[0];
                    f_7 = matchValue_1[1].fields[0];
                }
                else if (matchValue_1[1].tag === 18) {
                    pattern_matching_result = 34;
                    f_15 = matchValue_1[1].fields[0];
                    json_3 = matchValue_1[0];
                }
                else {
                    pattern_matching_result = 35;
                    wrong_1 = matchValue_1;
                }
            }
            else if (matchValue_1[0].tag === 5) {
                if (matchValue_1[1].tag === 27) {
                    pattern_matching_result = 19;
                    f_8 = matchValue_1[1].fields[0];
                    props = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 28) {
                    pattern_matching_result = 20;
                    f_9 = matchValue_1[1].fields[0];
                    props_1 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 33) {
                    pattern_matching_result = 21;
                    f_10 = matchValue_1[1].fields[0];
                    props_2 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 26) {
                    pattern_matching_result = 22;
                    f_11 = matchValue_1[1].fields[0];
                    props_3 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 34) {
                    pattern_matching_result = 23;
                    f_12 = matchValue_1[1].fields[0];
                    props_4 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 21) {
                    pattern_matching_result = 25;
                    f_14 = matchValue_1[1].fields[0];
                    props_6 = matchValue_1[0].fields[0];
                }
                else if (matchValue_1[1].tag === 18) {
                    pattern_matching_result = 34;
                    f_15 = matchValue_1[1].fields[0];
                    json_3 = matchValue_1[0];
                }
                else {
                    pattern_matching_result = 35;
                    wrong_1 = matchValue_1;
                }
            }
            else if (matchValue_1[0].tag === 3) {
                if (matchValue_1[1].tag === 21) {
                    pattern_matching_result = 24;
                }
                else if (matchValue_1[1].tag === 18) {
                    pattern_matching_result = 34;
                    f_15 = matchValue_1[1].fields[0];
                    json_3 = matchValue_1[0];
                }
                else {
                    pattern_matching_result = 35;
                    wrong_1 = matchValue_1;
                }
            }
            else if (matchValue_1[1].tag === 1) {
                pattern_matching_result = 0;
                v_1 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 24) {
                pattern_matching_result = 11;
                f = matchValue_1[1].fields[0];
                v_12 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 32) {
                pattern_matching_result = 12;
                f_1 = matchValue_1[1].fields[0];
                v_13 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 9) {
                pattern_matching_result = 27;
                v_16 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 17) {
                pattern_matching_result = 28;
                v_17 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 13) {
                pattern_matching_result = 29;
                v_18 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 14) {
                pattern_matching_result = 30;
                v_19 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 15) {
                pattern_matching_result = 33;
                v_22 = matchValue_1[0].fields[0];
            }
            else if (matchValue_1[1].tag === 18) {
                pattern_matching_result = 34;
                f_15 = matchValue_1[1].fields[0];
                json_3 = matchValue_1[0];
            }
            else {
                pattern_matching_result = 35;
                wrong_1 = matchValue_1;
            }
            switch (pattern_matching_result) {
                case 0: {
                    return v_1;
                }
                case 1: {
                    return v_2;
                }
                case 2: {
                    let value_2;
                    value_2 = (v_3 & 0xFF);
                    return value_2;
                }
                case 3: {
                    let value_4;
                    value_4 = ((v_4 + 0x8000 & 0xFFFF) - 0x8000);
                    return value_4;
                }
                case 4: {
                    let value_6;
                    value_6 = (v_5 & 0xFFFF);
                    return value_6;
                }
                case 5: {
                    let value_8;
                    value_8 = (~(~v_6));
                    return value_8;
                }
                case 6: {
                    let value_10;
                    value_10 = (v_7 >>> 0);
                    return value_10;
                }
                case 7: {
                    let value_12;
                    value_12 = fromNumber(v_8, false);
                    return value_12;
                }
                case 8: {
                    let value_14;
                    value_14 = fromNumber(v_9, true);
                    return value_14;
                }
                case 9: {
                    let value_16;
                    value_16 = v_10;
                    return value_16;
                }
                case 10: {
                    return v_11;
                }
                case 11: {
                    const value_18 = Int32Array.from(delay(() => map_6((idx) => (v_12.charCodeAt(idx)), rangeNumber(0, 1, v_12.length - 1))));
                    return value_18;
                }
                case 12: {
                    const patternInput = f_1();
                    const type$0027_1 = patternInput[1];
                    try {
                        return parseEnum(type$0027_1, v_13);
                    }
                    catch (err) {
                        let option_4;
                        let option_3;
                        const option_2 = SchemaModule_Annotator__Enum_Z721C83C5(ann, SchemaModule_nameFromTypeInfo(ti_1));
                        option_3 = bind((r_1) => r_1.Default, option_2);
                        option_4 = bind((_arg1) => {
                            if (_arg1.tag === 1) {
                                const arg0 = parseEnum(type$0027_1, _arg1.fields[0]);
                                return some(arg0);
                            }
                            else {
                                return void 0;
                            }
                        }, option_3);
                        return defaultArgWith(option_4, () => {
                            if (options.EvolutionTolerantMode) {
                                return parse(ti_1)(SchemaModule_stub(options.CustomRules, ti_1));
                            }
                            else {
                                const arg20 = name(type$0027_1);
                                const clo1 = toFail(printf("\u0027%s\u0027 was not found in %s set ForwardCompatibleMode=true for assign stub value, %A"));
                                const clo2 = clo1(v_13);
                                const clo3 = clo2(arg20);
                                return clo3(err);
                            }
                        });
                    }
                }
                case 13: {
                    const value_19 = parseArray(f_2())(elements_1);
                    return value_19;
                }
                case 14: {
                    let value_20;
                    const list_2 = parseArray(f_3())(elements_2);
                    value_20 = Array.from(list_2);
                    return value_20;
                }
                case 15: {
                    let value_21;
                    const arg00 = parseArray(f_4())(elements_3);
                    value_21 = Array.from(arg00);
                    return value_21;
                }
                case 16: {
                    let value_23;
                    let elements_5;
                    const list_3 = parseArray(f_5())(elements_4);
                    elements_5 = map_3((value_22) => value_22, list_3);
                    value_23 = ofList_1(elements_5, {
                        Compare: compare,
                    });
                    return value_23;
                }
                case 17: {
                    let value_24;
                    const arg00_1 = parseArray(f_6())(elements_6);
                    value_24 = (new Set(arg00_1));
                    return value_24;
                }
                case 18: {
                    const value_25 = parseArray(f_7())(elements_7);
                    return value_25;
                }
                case 19: {
                    const patternInput_1 = f_8();
                    let value_26;
                    value_26 = map_5((_arg1_1, jsonValue) => parse(patternInput_1[1])(jsonValue), props);
                    return value_26;
                }
                case 20: {
                    const patternInput_2 = f_9();
                    const dict = new Map([]);
                    iterate((key, jsonValue_1) => {
                        addToDict(dict, key, parse(patternInput_2[1])(jsonValue_1));
                    }, props_1);
                    return dict;
                }
                case 21: {
                    const patternInput_3 = f_10();
                    const recordType = patternInput_3[1];
                    let recordValues;
                    recordValues = map_4((field) => fieldValue(props_2)(() => SchemaModule_nameFromType(recordType))(field.FieldName)(field.FieldType), patternInput_3[0]);
                    return makeRecord(recordType, recordValues);
                }
                case 22: {
                    let value_27;
                    const array_2 = f_11();
                    value_27 = mapIndexed((idx_1, itemTypeInfo) => {
                        let fieldName;
                        const arg10_1 = (idx_1 + 1) | 0;
                        const clo1_1 = toText(printf("Item%d"));
                        fieldName = clo1_1(arg10_1);
                        return fieldValue(props_3)(() => SchemaModule_nameFromTypeInfo(ti_1))(fieldName)(itemTypeInfo);
                    }, array_2);
                    return value_27;
                }
                case 23: {
                    const patternInput_4 = f_12();
                    let patternInput_5;
                    let source;
                    source = toSeq(props_4);
                    patternInput_5 = head(source);
                    const json_2 = patternInput_5[1];
                    const caseName = patternInput_5[0];
                    if (json_2.tag === 5) {
                        let map_2;
                        const unionName = SchemaModule_nameFromType(patternInput_4[1]);
                        let matchValue;
                        let outArg = null;
                        matchValue = [tryGetValue(casesCache, unionName, new FSharpRef(() => outArg, (v) => {
                            outArg = v;
                        })), outArg];
                        if (matchValue[0]) {
                            map_2 = matchValue[1];
                        }
                        else {
                            let map_1;
                            let elements;
                            let list_1;
                            list_1 = ofArray_1(patternInput_4[0]);
                            elements = collect((case$) => {
                                let option_1, option;
                                const caseFullName = (unionName + ".") + case$.CaseName;
                                return cons([caseFullName, case$], (option_1 = (option = SchemaModule_Annotator__Record_Z721C83C5(ann, caseFullName), (map_7((r) => map_3((alias) => [alias, case$], r.Aliases), option))), (defaultArg(option_1, empty()))));
                            }, list_1);
                            map_1 = ofList(elements);
                            casesCache.set(unionName, map_1);
                            map_2 = map_1;
                        }
                        let option_6;
                        const option_5 = FSharpMap__TryFind(map_2, caseName);
                        option_6 = map_7((case$_1) => {
                            let unionFields;
                            const array_3 = getUnionCaseFields(case$_1.Info);
                            unionFields = mapIndexed((idx_2, pi) => fieldValue(json_2.fields[0])(() => caseName)(name(pi))(case$_1.CaseTypes[idx_2]), array_3);
                            return makeUnion(case$_1.Info, unionFields);
                        }, option_5);
                        return defaultArgWith(option_6, () => {
                            if (options.EvolutionTolerantMode) {
                                return parse(ti_1)(SchemaModule_stub(options.CustomRules, ti_1));
                            }
                            else {
                                const clo1_2 = toFail(printf("UnionCase:%s missed, set ForwardCompatibleMode=true for assign stub value"));
                                return clo1_2(caseName);
                            }
                        });
                    }
                    else {
                        const clo1_3 = toFail(printf("Union case expected to be in json object, but %A"));
                        return clo1_3(json_2);
                    }
                }
                case 24: {
                    return void 0;
                }
                case 25: {
                    let matchValue_2;
                    let source_1;
                    source_1 = toSeq(props_6);
                    matchValue_2 = tryHead(source_1);
                    if (matchValue_2 == null) {
                        throw (new Error("Option case should be represented as jobject with one property"));
                    }
                    else {
                        const jsonValue_2 = matchValue_2[1];
                        const parsedOptional = parse(f_14())(jsonValue_2);
                        return (some)(parsedOptional);
                    }
                }
                case 26: {
                    let value_29;
                    value_29 = (new Decimal(v_15));
                    return value_29;
                }
                case 27: {
                    return new Decimal(v_16);
                }
                case 28: {
                    const value_30 = parse_1(v_17);
                    return value_30;
                }
                case 29: {
                    const value_31 = parse_2(v_18, {}, 128);
                    return value_31;
                }
                case 30: {
                    const value_32 = parse_3(v_19, {}, 128);
                    return value_32;
                }
                case 31: {
                    return Math.floor(v_20);
                }
                case 32: {
                    return fromInt32(Math.floor(v_21));
                }
                case 33: {
                    const arg10_5 = parse_4(v_22);
                    return ((value_33) => value_33)(arg10_5);
                }
                case 34: {
                    const type$0027_2 = f_15();
                    const matchValue_3 = FSharpMap__TryFind(rulesMap_1, name(type$0027_2));
                    if (matchValue_3 != null) {
                        const rule = matchValue_3;
                        return rule.CastFromSurrogate(parse(rule.SurrogateTypeInfo)(json_3));
                    }
                    else {
                        const arg10_6 = f_15();
                        const clo1_6 = toFail(printf("Deserialization of the type is not supported: %A"));
                        return clo1_6(arg10_6);
                    }
                }
                case 35: {
                    const tupledArg = wrong_1;
                    const clo1_7 = toFail(printf("Deserialization of the type is not supported: %A"));
                    return clo1_7([tupledArg[0], tupledArg[1]]);
                }
            }
        });
        const parseArray = (elTypeInfo) => ((elements_8) => {
            const mapping_9 = parse(elTypeInfo);
            return map_3(mapping_9, elements_8);
        });
        const fieldValue = (props_7) => ((recordNameF) => ((fieldName_1) => ((fieldTypeInfo) => {
            let option_15;
            let option_10;
            const option_7 = FSharpMap__TryFind(props_7, fieldName_1);
            const mapping_10 = parse(fieldTypeInfo);
            option_10 = map_7(mapping_10, option_7);
            option_15 = defaultArgWith(option_10, () => {
                const recordName = recordNameF();
                let option_9;
                option_9 = SchemaModule_Annotator__Field(ann, recordName, fieldName_1);
                return bind((r_2) => {
                    let option_8;
                    let list_6;
                    list_6 = choose((arg00_3) => FSharpMap__TryFind(props_7, arg00_3), r_2.Aliases);
                    option_8 = tryHead_1(list_6);
                    const mapping_11 = parse(fieldTypeInfo);
                    return map_7(mapping_11, option_8);
                }, option_9);
            });
            return defaultArgWith(option_15, () => {
                const recordName_1 = recordNameF();
                let matchValue_4;
                let outArg_1 = null;
                matchValue_4 = [tryGetValue(defValues, [recordName_1, fieldName_1], new FSharpRef(() => outArg_1, (v_23) => {
                    outArg_1 = v_23;
                })), outArg_1];
                if (matchValue_4[0]) {
                    return matchValue_4[1];
                }
                else {
                    let v_25;
                    let option_14;
                    let option_13;
                    option_13 = SchemaModule_Annotator__Field(ann, recordName_1, fieldName_1);
                    option_14 = bind((r_3) => {
                        let option_12;
                        option_12 = map_7((defJson) => {
                            if (fieldTypeInfo.tag === 34) {
                                const patternInput_6 = fieldTypeInfo.fields[0]();
                                let arg0_2;
                                const elements_9 = singleton([(SchemaModule_nameFromType(patternInput_6[1]) + ".") + name(patternInput_6[0][0].Info), defJson]);
                                arg0_2 = ofList(elements_9);
                                return new Json(5, arg0_2);
                            }
                            else {
                                return defJson;
                            }
                        }, r_3.Default);
                        const mapping_13 = parse(fieldTypeInfo);
                        return map_7(mapping_13, option_12);
                    }, option_13);
                    v_25 = defaultArgWith(option_14, () => {
                        if (options.EvolutionTolerantMode) {
                            return parse(fieldTypeInfo)(SchemaModule_stub(options.CustomRules, fieldTypeInfo));
                        }
                        else {
                            const clo1_8 = toFail(printf("Record:%s Field:%s missed, set ForwardCompatibleMode=true for assign stub value"));
                            const clo2_1 = clo1_8(recordName_1);
                            return clo2_1(fieldName_1);
                        }
                    });
                    defValues.set([recordName_1, fieldName_1], v_25);
                    return v_25;
                }
            });
        })));
        return parse(ti)(json);
    };
}

