import { toString, FSharpRef, Record, Union } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Types.js";
import { name as name_3, getUnionCaseFields, getEnumName, getEnumValues, getGenerics, obj_type, getGenericTypeDefinition, equals, isGenericType, fullName, bool_type, class_type, int32_type, option_type, record_type, list_type, string_type, union_type, array_type } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Reflection.js";
import { Json, Json$reflection } from "../test/.fable/Fable.SimpleJson.3.16.2/Json.fs.js";
import { TypeInfo$reflection } from "../test/.fable/Fable.SimpleJson.3.16.2/TypeInfo.fs.js";
import { CustomRuleModule_buidInRules, CustomRule$reflection } from "./CustomRule.fs.js";
import { toText, join, replace, printf, toFail, substring } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/String.js";
import { toSeq, ofList, ofArray, empty as empty_1, FSharpMap__get_Item, FSharpMap__TryFind } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Map.js";
import { ofSeq, ofArray as ofArray_1, cons as cons_1, append, singleton, tryFind, iterate, empty, map, choose } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/List.js";
import { tryGetValue } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/MapUtil.js";
import { comparePrimitives, partialApply } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Util.js";
import { SimpleJson_toString, SimpleJson_tryParse, SimpleJson_parse } from "../test/.fable/Fable.SimpleJson.3.16.2/SimpleJson.fs.js";
import { toArray, defaultArgWith, bind, map as map_1, defaultArg } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Option.js";
import { equalsWith, addRangeInPlace, zip, mapIndexed, head as head_2, sortBy, map as map_2 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Array.js";
import { Result_Bind, Result_Map, Result_MapError, FSharpResult$2 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Choice.js";
import { createTypeInfo } from "../test/.fable/Fable.SimpleJson.3.16.2/TypeInfo.Converter.fs.js";
import { singleton as singleton_1, append as append_1, head as head_3, getEnumerator, enumerateFromFunctions, map as map_3, delay } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Seq.js";
import { parse as parse_1 } from "../test/.fable/fable-library.3.0.0-nagareyama-rc-004/Int32.js";

export class Schema extends Union {
    constructor(tag, ...fields) {
        super();
        this.tag = (tag | 0);
        this.fields = fields;
    }
    cases() {
        return ["Null", "Boolean", "Int", "Long", "Float", "Double", "Bytes", "String", "Record", "Enum", "Array", "Map", "Union", "Fixed"];
    }
}

export function Schema$reflection() {
    return union_type("Fable.Avro.Schema", [], Schema, () => [[], [], [], [], [], [], [], [], [["Item", RecordSchema$reflection()]], [["Item", EnumSchema$reflection()]], [["Item", ArraySchema$reflection()]], [["Item", MapSchema$reflection()]], [["Item", array_type(Schema$reflection())]], [["Item", FixedSchema$reflection()]]]);
}

export class RecordSchema extends Record {
    constructor(Name, Aliases, Fields) {
        super();
        this.Name = Name;
        this.Aliases = Aliases;
        this.Fields = Fields;
    }
}

export function RecordSchema$reflection() {
    return record_type("Fable.Avro.RecordSchema", [], RecordSchema, () => [["Name", string_type], ["Aliases", list_type(string_type)], ["Fields", array_type(RecordField$reflection())]]);
}

export class RecordField extends Record {
    constructor(Name, Aliases, Type, Default) {
        super();
        this.Name = Name;
        this.Aliases = Aliases;
        this.Type = Type;
        this.Default = Default;
    }
}

export function RecordField$reflection() {
    return record_type("Fable.Avro.RecordField", [], RecordField, () => [["Name", string_type], ["Aliases", list_type(string_type)], ["Type", Schema$reflection()], ["Default", option_type(Json$reflection())]]);
}

export class EnumSchema extends Record {
    constructor(Name, Aliases, Symbols, Default) {
        super();
        this.Name = Name;
        this.Aliases = Aliases;
        this.Symbols = Symbols;
        this.Default = Default;
    }
}

export function EnumSchema$reflection() {
    return record_type("Fable.Avro.EnumSchema", [], EnumSchema, () => [["Name", string_type], ["Aliases", list_type(string_type)], ["Symbols", array_type(string_type)], ["Default", option_type(Json$reflection())]]);
}

export class ArraySchema extends Record {
    constructor(Items, Default) {
        super();
        this.Items = Items;
        this.Default = Default;
    }
}

export function ArraySchema$reflection() {
    return record_type("Fable.Avro.ArraySchema", [], ArraySchema, () => [["Items", Schema$reflection()], ["Default", option_type(Json$reflection())]]);
}

export class MapSchema extends Record {
    constructor(Values, Default) {
        super();
        this.Values = Values;
        this.Default = Default;
    }
}

export function MapSchema$reflection() {
    return record_type("Fable.Avro.MapSchema", [], MapSchema, () => [["Values", Schema$reflection()], ["Default", option_type(Json$reflection())]]);
}

export class FixedSchema extends Record {
    constructor(Name, Aliases, Size) {
        super();
        this.Name = Name;
        this.Aliases = Aliases;
        this.Size = (Size | 0);
    }
}

export function FixedSchema$reflection() {
    return record_type("Fable.Avro.FixedSchema", [], FixedSchema, () => [["Name", string_type], ["Aliases", list_type(string_type)], ["Size", int32_type]]);
}

export class SchemaError extends Union {
    constructor(tag, ...fields) {
        super();
        this.tag = (tag | 0);
        this.fields = fields;
    }
    cases() {
        return ["AggregateError", "NotSupportedType", "NotSupportedTypeInfo"];
    }
}

export function SchemaError$reflection() {
    return union_type("Fable.Avro.SchemaError", [], SchemaError, () => [[["Item", list_type(SchemaError$reflection())]], [["Item", class_type("System.Type")]], [["Item", TypeInfo$reflection()]]]);
}

export class SchemaOptions extends Record {
    constructor(CustomRules, Annotations, StubDefaultValues) {
        super();
        this.CustomRules = CustomRules;
        this.Annotations = Annotations;
        this.StubDefaultValues = StubDefaultValues;
    }
}

export function SchemaOptions$reflection() {
    return record_type("Fable.Avro.SchemaOptions", [], SchemaOptions, () => [["CustomRules", list_type(CustomRule$reflection())], ["Annotations", string_type], ["StubDefaultValues", bool_type]]);
}

export const SchemaModule_defaultOptions = new SchemaOptions(CustomRuleModule_buidInRules, "", false);

function SchemaModule_canonicalName(ns, name) {
    const matchValue = name.lastIndexOf(".") | 0;
    if (matchValue === -1) {
        return [ns, (ns !== "") ? ((ns + ".") + name) : name];
    }
    else {
        return [substring(name, 0, matchValue), name];
    }
}

function SchemaModule_getStringProp(fields, propertyName) {
    const matchValue = FSharpMap__TryFind(fields, propertyName);
    let pattern_matching_result, v;
    if (matchValue != null) {
        if (matchValue.tag === 1) {
            pattern_matching_result = 0;
            v = matchValue.fields[0];
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return v;
        }
        case 1: {
            const clo1 = toFail(printf("string property \u0027%s\u0027 is absent in %A"));
            const clo2 = clo1(propertyName);
            return clo2(fields);
        }
    }
}

function SchemaModule_getNumberProp(fields, propertyName) {
    const matchValue = FSharpMap__TryFind(fields, propertyName);
    let pattern_matching_result, v;
    if (matchValue != null) {
        if (matchValue.tag === 0) {
            pattern_matching_result = 0;
            v = matchValue.fields[0];
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return v;
        }
        case 1: {
            const clo1 = toFail(printf("string property \u0027%s\u0027 is absent in %A"));
            const clo2 = clo1(propertyName);
            return clo2(fields);
        }
    }
}

const SchemaModule_getStringList = (list) => choose((_arg1) => {
    if (_arg1.tag === 1) {
        return _arg1.fields[0];
    }
    else {
        return void 0;
    }
}, list);

function SchemaModule_getName(ns, props) {
    let ns_1;
    const matchValue = FSharpMap__TryFind(props, "namespace");
    let pattern_matching_result, v;
    if (matchValue != null) {
        if (matchValue.tag === 1) {
            pattern_matching_result = 0;
            v = matchValue.fields[0];
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            ns_1 = v;
            break;
        }
        case 1: {
            ns_1 = ns;
            break;
        }
    }
    return SchemaModule_canonicalName(ns_1, SchemaModule_getStringProp(props, "name"));
}

function SchemaModule_getFullName(props) {
    const tuple = SchemaModule_getName("", props);
    return tuple[1];
}

function SchemaModule_getAliases(ns, props) {
    const matchValue = FSharpMap__TryFind(props, "aliases");
    let pattern_matching_result, list;
    if (matchValue != null) {
        if (matchValue.tag === 4) {
            pattern_matching_result = 0;
            list = matchValue.fields[0];
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            const list_1 = SchemaModule_getStringList(list);
            return map((arg) => {
                let tuple;
                tuple = SchemaModule_canonicalName(ns, arg);
                return tuple[1];
            }, list_1);
        }
        case 1: {
            return empty();
        }
    }
}

function SchemaModule_getSymbols(props) {
    const matchValue = FSharpMap__TryFind(props, "symbols");
    let pattern_matching_result, list;
    if (matchValue != null) {
        if (matchValue.tag === 4) {
            pattern_matching_result = 0;
            list = matchValue.fields[0];
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            const list_1 = SchemaModule_getStringList(list);
            return Array.from(list_1);
        }
        case 1: {
            return [];
        }
    }
}

function SchemaModule_getDefault(props) {
    return FSharpMap__TryFind(props, "default");
}

export function SchemaModule_ofString(jsonString) {
    const cache = new Map([]);
    const parse = (ns_mut, _arg1_mut) => {
        let tuple, value;
        parse:
        while (true) {
            const ns = ns_mut, _arg1 = _arg1_mut;
            if (_arg1.tag === 3) {
                return new Schema(0);
            }
            else if (_arg1.tag === 1) {
                if (_arg1.fields[0] === "null") {
                    return new Schema(0);
                }
                else if (_arg1.fields[0] === "string") {
                    return new Schema(7);
                }
                else if (_arg1.fields[0] === "boolean") {
                    return new Schema(1);
                }
                else if (_arg1.fields[0] === "int") {
                    return new Schema(2);
                }
                else if (_arg1.fields[0] === "long") {
                    return new Schema(3);
                }
                else if (_arg1.fields[0] === "float") {
                    return new Schema(4);
                }
                else if (_arg1.fields[0] === "double") {
                    return new Schema(5);
                }
                else if (_arg1.fields[0] === "bytes") {
                    return new Schema(6);
                }
                else {
                    let matchValue;
                    let outArg = null;
                    matchValue = [tryGetValue(cache, (tuple = SchemaModule_canonicalName(ns, _arg1.fields[0]), (tuple[1])), new FSharpRef(() => outArg, (v) => {
                        outArg = v;
                    })), outArg];
                    if (matchValue[0]) {
                        return matchValue[1];
                    }
                    else {
                        const clo1 = toFail(printf("Unknown type: %s"));
                        return clo1(_arg1.fields[0]);
                    }
                }
            }
            else if (_arg1.tag === 5) {
                const matchValue_1 = FSharpMap__get_Item(_arg1.fields[0], "type");
                let pattern_matching_result, json;
                if (matchValue_1.tag === 1) {
                    if (matchValue_1.fields[0] === "array") {
                        pattern_matching_result = 0;
                    }
                    else if (matchValue_1.fields[0] === "map") {
                        pattern_matching_result = 1;
                    }
                    else if (matchValue_1.fields[0] === "enum") {
                        pattern_matching_result = 2;
                    }
                    else if (matchValue_1.fields[0] === "record") {
                        pattern_matching_result = 3;
                    }
                    else if (matchValue_1.fields[0] === "fixed") {
                        pattern_matching_result = 4;
                    }
                    else {
                        pattern_matching_result = 5;
                        json = matchValue_1;
                    }
                }
                else {
                    pattern_matching_result = 5;
                    json = matchValue_1;
                }
                switch (pattern_matching_result) {
                    case 0: {
                        return new Schema(10, new ArraySchema(parse(ns, FSharpMap__get_Item(_arg1.fields[0], "items")), SchemaModule_getDefault(_arg1.fields[0])));
                    }
                    case 1: {
                        return new Schema(11, new MapSchema(parse(ns, FSharpMap__get_Item(_arg1.fields[0], "values")), SchemaModule_getDefault(_arg1.fields[0])));
                    }
                    case 2: {
                        const patternInput = SchemaModule_getName(ns, _arg1.fields[0]);
                        const name = patternInput[1];
                        const schema_1 = new Schema(9, new EnumSchema(name, SchemaModule_getAliases(patternInput[0], _arg1.fields[0]), SchemaModule_getSymbols(_arg1.fields[0]), SchemaModule_getDefault(_arg1.fields[0])));
                        cache.set(name, schema_1);
                        return schema_1;
                    }
                    case 3: {
                        const patternInput_1 = SchemaModule_getName(ns, _arg1.fields[0]);
                        const ns_2 = patternInput_1[0];
                        const name_1 = patternInput_1[1];
                        const fields = [];
                        const schema_2 = new Schema(8, new RecordSchema(name_1, SchemaModule_getAliases(ns_2, _arg1.fields[0]), fields));
                        cache.set(name_1, schema_2);
                        const matchValue_2 = FSharpMap__get_Item(_arg1.fields[0], "fields");
                        if (matchValue_2.tag === 4) {
                            iterate((fieldJson) => {
                                if (fieldJson.tag === 5) {
                                    const props_1 = fieldJson.fields[0];
                                    const arg00 = new RecordField(SchemaModule_getStringProp(props_1, "name"), SchemaModule_getAliases("", props_1), parse(ns_2, FSharpMap__get_Item(props_1, "type")), SchemaModule_getDefault(props_1));
                                    void (fields.push(arg00));
                                }
                                else {
                                    const clo1_1 = toFail(printf("wrong json for field item property %A"));
                                    clo1_1(fieldJson);
                                }
                            }, matchValue_2.fields[0]);
                            return schema_2;
                        }
                        else {
                            const clo1_2 = toFail(printf("wrong json for \u0027fields\u0027 property %A"));
                            return clo1_2(matchValue_2);
                        }
                    }
                    case 4: {
                        const patternInput_2 = SchemaModule_getName(ns, _arg1.fields[0]);
                        const name_2 = patternInput_2[1];
                        const schema_3 = new Schema(13, new FixedSchema(name_2, SchemaModule_getAliases(patternInput_2[0], _arg1.fields[0]), (value = SchemaModule_getNumberProp(_arg1.fields[0], "size"), (~(~value)))));
                        cache.set(name_2, schema_3);
                        return schema_3;
                    }
                    case 5: {
                        ns_mut = ns;
                        _arg1_mut = json;
                        continue parse;
                    }
                }
            }
            else if (_arg1.tag === 4) {
                let arg0;
                let list_4;
                const mapping = partialApply(1, parse, [ns]);
                list_4 = map(mapping, _arg1.fields[0]);
                arg0 = Array.from(list_4);
                return new Schema(12, arg0);
            }
            else {
                const clo1_3 = toFail(printf("wrong json %A"));
                return clo1_3(_arg1);
            }
            break;
        }
    };
    return parse("", SimpleJson_parse(jsonString));
}

export class SchemaModule_Annotator {
    constructor(jsonString) {
        let json;
        const option = SimpleJson_tryParse(jsonString);
        const value = new Json(5, empty_1());
        json = defaultArg(option, value);
        let option_2;
        const props = SchemaModule_Annotator__getProps_Z3E28EAD9(this, json);
        option_2 = SchemaModule_Annotator__getList(this, "records", props);
        this.records = map_1((list_1) => map((json_1) => {
            let option_1;
            const props_1 = SchemaModule_Annotator__getProps_Z3E28EAD9(this, json_1);
            const Name = SchemaModule_getFullName(props_1);
            return {
                Aliases: SchemaModule_getAliases("", props_1),
                Fields: (option_1 = SchemaModule_Annotator__getList(this, "fields", props_1), (map_1((list) => map((arg) => {
                    let props_2;
                    props_2 = SchemaModule_Annotator__getProps_Z3E28EAD9(this, arg);
                    return SchemaModule_Annotator__field_169BB3C2(this, props_2);
                }, list), option_1))),
                Name: Name,
            };
        }, list_1), option_2);
        let option_3;
        const props_3 = SchemaModule_Annotator__getProps_Z3E28EAD9(this, json);
        option_3 = SchemaModule_Annotator__getList(this, "enums", props_3);
        this.enums = map_1((list_2) => map((json_2) => {
            const props_4 = SchemaModule_Annotator__getProps_Z3E28EAD9(this, json_2);
            const Name_1 = SchemaModule_getFullName(props_4);
            return {
                Aliases: SchemaModule_getAliases("", props_4),
                Default: FSharpMap__TryFind(props_4, "default"),
                Name: Name_1,
            };
        }, list_2), option_3);
    }
}

export function SchemaModule_Annotator$reflection() {
    return class_type("Fable.Avro.SchemaModule.Annotator", void 0, SchemaModule_Annotator);
}

export function SchemaModule_Annotator_$ctor_Z721C83C5(jsonString) {
    return new SchemaModule_Annotator(jsonString);
}

export function SchemaModule_Annotator__Enum_Z721C83C5(_, name) {
    return bind((list) => tryFind((r) => (r.Name === name), list), _.enums);
}

export function SchemaModule_Annotator__Record_Z721C83C5(_, name) {
    return bind((list) => tryFind((r) => (r.Name === name), list), _.records);
}

export function SchemaModule_Annotator__Field(this$, recordName, fieldName) {
    const option_1 = SchemaModule_Annotator__Record_Z721C83C5(this$, recordName);
    return bind((r) => bind((list) => tryFind((fr) => (fr.Name === fieldName), list), r.Fields), option_1);
}

function SchemaModule_Annotator__getProps_Z3E28EAD9(this$, _arg1) {
    if (_arg1.tag === 5) {
        return _arg1.fields[0];
    }
    else {
        const clo1 = toFail(printf("expected object but get %A"));
        return clo1(_arg1);
    }
}

function SchemaModule_Annotator__getList(this$, name, props) {
    const option = FSharpMap__TryFind(props, name);
    return bind((_arg2) => {
        if (_arg2.tag === 4) {
            return _arg2.fields[0];
        }
        else {
            return void 0;
        }
    }, option);
}

function SchemaModule_Annotator__field_169BB3C2(this$, props) {
    const Name = SchemaModule_getFullName(props);
    return {
        Aliases: SchemaModule_getAliases("", props),
        Default: FSharpMap__TryFind(props, "default"),
        Name: Name,
    };
}

export function SchemaModule_nameFromTypeInfo(_arg1) {
    let strings, array;
    let pattern_matching_result, f;
    switch (_arg1.tag) {
        case 1: {
            pattern_matching_result = 0;
            break;
        }
        case 6: {
            pattern_matching_result = 1;
            break;
        }
        case 5: {
            pattern_matching_result = 2;
            break;
        }
        case 11: {
            pattern_matching_result = 3;
            break;
        }
        case 7: {
            pattern_matching_result = 4;
            break;
        }
        case 8: {
            pattern_matching_result = 5;
            break;
        }
        case 12: {
            pattern_matching_result = 6;
            break;
        }
        case 10: {
            pattern_matching_result = 7;
            break;
        }
        case 2: {
            pattern_matching_result = 8;
            break;
        }
        case 3: {
            pattern_matching_result = 9;
            break;
        }
        case 4: {
            pattern_matching_result = 10;
            break;
        }
        case 24: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 29: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 30: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 23: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 25: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 22: {
            pattern_matching_result = 11;
            f = _arg1.fields[0];
            break;
        }
        case 27: {
            pattern_matching_result = 12;
            break;
        }
        case 28: {
            pattern_matching_result = 13;
            break;
        }
        case 32: {
            pattern_matching_result = 14;
            break;
        }
        case 33: {
            pattern_matching_result = 15;
            break;
        }
        case 26: {
            pattern_matching_result = 16;
            break;
        }
        case 21: {
            pattern_matching_result = 17;
            break;
        }
        case 34: {
            pattern_matching_result = 18;
            break;
        }
        case 18: {
            pattern_matching_result = 19;
            break;
        }
        case 17: {
            pattern_matching_result = 20;
            break;
        }
        case 13: {
            pattern_matching_result = 21;
            break;
        }
        case 14: {
            pattern_matching_result = 22;
            break;
        }
        case 16: {
            pattern_matching_result = 23;
            break;
        }
        case 9: {
            pattern_matching_result = 24;
            break;
        }
        case 15: {
            pattern_matching_result = 25;
            break;
        }
        default: pattern_matching_result = 26}
    switch (pattern_matching_result) {
        case 0: {
            return "String";
        }
        case 1: {
            return "Boolean";
        }
        case 2: {
            return "Int32";
        }
        case 3: {
            return "Int64";
        }
        case 4: {
            return "Float";
        }
        case 5: {
            return "Double";
        }
        case 6: {
            return "Byte";
        }
        case 7: {
            return "Short";
        }
        case 8: {
            return "UInt16";
        }
        case 9: {
            return "UInt32";
        }
        case 10: {
            return "UInt64";
        }
        case 11: {
            return "Array_Of_" + SchemaModule_nameFromTypeInfo(f());
        }
        case 12: {
            const patternInput = _arg1.fields[0]();
            return "Map_Of_" + SchemaModule_nameFromTypeInfo(patternInput[1]);
        }
        case 13: {
            const patternInput_1 = _arg1.fields[0]();
            return "Map_Of_" + SchemaModule_nameFromTypeInfo(patternInput_1[1]);
        }
        case 14: {
            const patternInput_2 = _arg1.fields[0]();
            const name = replace(fullName(patternInput_2[1]), "+", ".");
            return substring(name, 0, name.indexOf("["));
        }
        case 15: {
            const patternInput_3 = _arg1.fields[0]();
            return SchemaModule_nameFromType(patternInput_3[1]);
        }
        case 16: {
            return "Tuple_Of_" + (strings = (array = _arg1.fields[0](), (map_2(SchemaModule_nameFromTypeInfo, array))), (join("_And_", strings)));
        }
        case 17: {
            return "Nullable_" + SchemaModule_nameFromTypeInfo(_arg1.fields[0]());
        }
        case 18: {
            const patternInput_4 = _arg1.fields[0]();
            return SchemaModule_nameFromType(patternInput_4[1]);
        }
        case 19: {
            return SchemaModule_nameFromType(_arg1.fields[0]());
        }
        case 20: {
            return "Guid";
        }
        case 21: {
            return "DateTime";
        }
        case 22: {
            return "DateTimeOffset";
        }
        case 23: {
            return "TimeSpan";
        }
        case 24: {
            return "Decimal";
        }
        case 25: {
            return "BigInt";
        }
        case 26: {
            const clo1 = toFail(printf("Name for the type is not supported: %A"));
            return clo1(_arg1);
        }
    }
}

export function SchemaModule_nameFromType(type$0027) {
    let t;
    const name = replace(fullName(type$0027), "+", ".");
    const name_1 = (name.indexOf("System.") === 0) ? substring(name, "System.".length) : name;
    const name_2 = (t = type$0027, isGenericType(t) ? equals(getGenericTypeDefinition(t), union_type("Microsoft.FSharp.Core.FSharpResult`2", [obj_type, obj_type], FSharpResult$2, () => [[["ResultValue", obj_type]], [["ErrorValue", obj_type]]])) : false) ? "Result`" : name_1;
    const matchValue = name_2.indexOf("`") | 0;
    if (matchValue === -1) {
        return name_2;
    }
    else {
        const arg10 = substring(name_2, 0, matchValue);
        let arg20;
        let strings;
        const array = getGenerics(type$0027);
        strings = map_2((arg) => {
            let _arg1;
            _arg1 = createTypeInfo(arg);
            return SchemaModule_nameFromTypeInfo(_arg1);
        }, array);
        arg20 = join("_And_", strings);
        const clo1 = toText(printf("%s_Of_%s"));
        const clo2 = clo1(arg10);
        return clo2(arg20);
    }
}

export function SchemaModule_stub(customRules, _arg1) {
    switch (_arg1.tag) {
        case 1: {
            return new Json(1, "");
        }
        case 6: {
            return new Json(2, false);
        }
        case 12:
        case 10:
        case 2:
        case 5:
        case 3:
        case 11:
        case 4:
        case 7:
        case 8: {
            return new Json(0, 0);
        }
        case 24: {
            const matchValue = _arg1.fields[0]();
            if (matchValue.tag === 12) {
                return new Json(1, "");
            }
            else {
                return new Json(4, empty());
            }
        }
        case 29:
        case 30:
        case 23:
        case 25:
        case 22: {
            return new Json(4, empty());
        }
        case 27:
        case 28: {
            return new Json(5, empty_1());
        }
        case 32: {
            const patternInput = _arg1.fields[0]();
            const type$0027 = patternInput[1];
            let obj_2;
            let array_1;
            const array = Array.from(delay(() => {
                let inputSequence;
                return map_3((obj) => obj, (inputSequence = getEnumValues(type$0027), enumerateFromFunctions(() => getEnumerator(inputSequence), (enumerator) => enumerator["System.Collections.IEnumerator.MoveNext"](), (enumerator_1) => enumerator_1["System.Collections.IEnumerator.get_Current"]())));
            }));
            array_1 = sortBy((obj_1) => parse_1(toString(obj_1), 511, false, 32), array, {
                Compare: comparePrimitives,
            });
            obj_2 = head_2(array_1);
            const arg0 = getEnumName(type$0027, obj_2);
            return new Json(1, arg0);
        }
        case 33: {
            const patternInput_1 = _arg1.fields[0]();
            let arg0_1;
            let elements;
            elements = map_2((fi) => [fi.FieldName, SchemaModule_stub(customRules, fi.FieldType)], patternInput_1[0]);
            arg0_1 = ofArray(elements);
            return new Json(5, arg0_1);
        }
        case 26: {
            let arg0_2;
            let elements_1;
            const array_3 = _arg1.fields[0]();
            elements_1 = mapIndexed((idx, ti) => {
                let arg10, clo1;
                return [(arg10 = ((idx + 1) | 0), (clo1 = toText(printf("Item%d")), clo1(arg10))), SchemaModule_stub(customRules, ti)];
            }, array_3);
            arg0_2 = ofArray(elements_1);
            return new Json(5, arg0_2);
        }
        case 21: {
            return new Json(3);
        }
        case 34: {
            const patternInput_2 = _arg1.fields[0]();
            const case$ = patternInput_2[0][0];
            let recordJson;
            let arg0_3;
            let elements_2;
            const array_4 = zip(getUnionCaseFields(case$.Info), case$.CaseTypes);
            elements_2 = map_2((tupledArg) => [name_3(tupledArg[0]), SchemaModule_stub(customRules, tupledArg[1])], array_4);
            arg0_3 = ofArray(elements_2);
            recordJson = (new Json(5, arg0_3));
            let arg0_4;
            const elements_3 = singleton([(SchemaModule_nameFromType(patternInput_2[1]) + ".") + name_3(case$.Info), recordJson]);
            arg0_4 = ofList(elements_3);
            return new Json(5, arg0_4);
        }
        case 18: {
            const type$0027_1 = _arg1.fields[0]();
            let matchValue_1;
            matchValue_1 = tryFind((t) => equals(type$0027_1, t.InstanceType), customRules);
            if (matchValue_1 == null) {
                const clo1_1 = toFail(printf("Can not resolve stub for: %A"));
                return clo1_1(type$0027_1);
            }
            else {
                const rule = matchValue_1;
                return rule.StubValue;
            }
        }
        case 9: {
            return new Json(0, 0);
        }
        case 15: {
            return new Json(1, "0");
        }
        case 17: {
            return new Json(1, "00000000-0000-0000-0000-000000000000");
        }
        case 13: {
            return new Json(1, "1970-01-01T00:00:00.000Z");
        }
        case 14: {
            return new Json(1, "1970-01-01T00:00:00.000+00:00");
        }
        case 16: {
            return new Json(0, 0);
        }
        default: {
            const clo1_2 = toFail(printf("Can not resolve stub for: %A"));
            return clo1_2(_arg1);
        }
    }
}

function SchemaModule_traverse(f, list) {
    let result;
    const op_LessMultiplyGreater = (fResult, xResult) => {
        const matchValue = [fResult, xResult];
        const copyOfStruct = matchValue[0];
        if (copyOfStruct.tag === 1) {
            const copyOfStruct_1 = matchValue[1];
            if (copyOfStruct_1.tag === 1) {
                return new FSharpResult$2(1, append(copyOfStruct.fields[0], copyOfStruct_1.fields[0]));
            }
            else {
                return new FSharpResult$2(1, copyOfStruct.fields[0]);
            }
        }
        else {
            const copyOfStruct_2 = matchValue[1];
            if (copyOfStruct_2.tag === 1) {
                return new FSharpResult$2(1, copyOfStruct_2.fields[0]);
            }
            else {
                const arg0 = copyOfStruct.fields[0](copyOfStruct_2.fields[0]);
                return new FSharpResult$2(0, arg0);
            }
        }
    };
    if (list.tail != null) {
        return op_LessMultiplyGreater(op_LessMultiplyGreater(new FSharpResult$2(0, (head) => ((tail) => cons_1(head, tail))), (result = f(list.head), (Result_MapError(singleton, result)))), SchemaModule_traverse(f, list.tail));
    }
    else {
        return new FSharpResult$2(0, empty());
    }
}

export function SchemaModule_generate(options, type$0027) {
    const cache = new Map([]);
    const annotator = SchemaModule_Annotator_$ctor_Z721C83C5(options.Annotations);
    const typeInfo = createTypeInfo(type$0027);
    const customRules = options.CustomRules;
    const gen = (ti_mut) => {
        let option_1, option, array_1, array, option_3, option_2, array_3, array_5, array_4;
        gen:
        while (true) {
            const ti = ti_mut;
            let pattern_matching_result, f_1;
            switch (ti.tag) {
                case 1: {
                    pattern_matching_result = 0;
                    break;
                }
                case 6: {
                    pattern_matching_result = 1;
                    break;
                }
                case 12: {
                    pattern_matching_result = 2;
                    break;
                }
                case 10: {
                    pattern_matching_result = 3;
                    break;
                }
                case 2: {
                    pattern_matching_result = 4;
                    break;
                }
                case 5: {
                    pattern_matching_result = 5;
                    break;
                }
                case 3: {
                    pattern_matching_result = 6;
                    break;
                }
                case 11: {
                    pattern_matching_result = 7;
                    break;
                }
                case 4: {
                    pattern_matching_result = 8;
                    break;
                }
                case 7: {
                    pattern_matching_result = 9;
                    break;
                }
                case 8: {
                    pattern_matching_result = 10;
                    break;
                }
                case 24: {
                    pattern_matching_result = 11;
                    break;
                }
                case 29: {
                    pattern_matching_result = 12;
                    f_1 = ti.fields[0];
                    break;
                }
                case 23: {
                    pattern_matching_result = 12;
                    f_1 = ti.fields[0];
                    break;
                }
                case 30: {
                    pattern_matching_result = 12;
                    f_1 = ti.fields[0];
                    break;
                }
                case 25: {
                    pattern_matching_result = 12;
                    f_1 = ti.fields[0];
                    break;
                }
                case 22: {
                    pattern_matching_result = 12;
                    f_1 = ti.fields[0];
                    break;
                }
                case 27: {
                    pattern_matching_result = 13;
                    break;
                }
                case 28: {
                    pattern_matching_result = 14;
                    break;
                }
                case 32: {
                    pattern_matching_result = 15;
                    break;
                }
                case 33: {
                    pattern_matching_result = 16;
                    break;
                }
                case 26: {
                    pattern_matching_result = 17;
                    break;
                }
                case 21: {
                    pattern_matching_result = 18;
                    break;
                }
                case 34: {
                    pattern_matching_result = 19;
                    break;
                }
                case 9: {
                    pattern_matching_result = 20;
                    break;
                }
                case 15: {
                    pattern_matching_result = 21;
                    break;
                }
                case 17: {
                    pattern_matching_result = 22;
                    break;
                }
                case 13: {
                    pattern_matching_result = 23;
                    break;
                }
                case 14: {
                    pattern_matching_result = 24;
                    break;
                }
                case 16: {
                    pattern_matching_result = 25;
                    break;
                }
                case 18: {
                    pattern_matching_result = 26;
                    break;
                }
                default: pattern_matching_result = 27}
            switch (pattern_matching_result) {
                case 0: {
                    return new FSharpResult$2(0, new Schema(7));
                }
                case 1: {
                    return new FSharpResult$2(0, new Schema(1));
                }
                case 2: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 3: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 4: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 5: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 6: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 7: {
                    return new FSharpResult$2(0, new Schema(3));
                }
                case 8: {
                    return new FSharpResult$2(0, new Schema(3));
                }
                case 9: {
                    return new FSharpResult$2(0, new Schema(4));
                }
                case 10: {
                    return new FSharpResult$2(0, new Schema(5));
                }
                case 11: {
                    const matchValue = ti.fields[0]();
                    if (matchValue.tag === 12) {
                        return new FSharpResult$2(0, new Schema(6));
                    }
                    else {
                        const result = gen(matchValue);
                        return Result_Map((schema) => (new Schema(10, new ArraySchema(schema, void 0))), result);
                    }
                }
                case 12: {
                    const result_1 = gen(f_1());
                    return Result_Map((schema_1) => (new Schema(10, new ArraySchema(schema_1, void 0))), result_1);
                }
                case 13: {
                    const patternInput = ti.fields[0]();
                    const result_2 = gen(patternInput[1]);
                    return Result_Map((schema_2) => (new Schema(11, new MapSchema(schema_2, void 0))), result_2);
                }
                case 14: {
                    const patternInput_1 = ti.fields[0]();
                    const result_3 = gen(patternInput_1[1]);
                    return Result_Map((schema_3) => (new Schema(11, new MapSchema(schema_3, void 0))), result_3);
                }
                case 15: {
                    const patternInput_2 = ti.fields[0]();
                    const type$0027_1 = patternInput_2[1];
                    const name = SchemaModule_nameFromTypeInfo(ti);
                    const schema_4 = new Schema(9, new EnumSchema(name, (option_1 = (option = SchemaModule_Annotator__Enum_Z721C83C5(annotator, name), (map_1((r) => r.Aliases, option))), (defaultArg(option_1, empty()))), (array_1 = (array = Array.from(delay(() => {
                        let inputSequence;
                        return map_3((obj) => obj, (inputSequence = getEnumValues(type$0027_1), enumerateFromFunctions(() => getEnumerator(inputSequence), (enumerator) => enumerator["System.Collections.IEnumerator.MoveNext"](), (enumerator_1) => enumerator_1["System.Collections.IEnumerator.get_Current"]())));
                    })), (sortBy((obj_1) => parse_1(toString(obj_1), 511, false, 32), array, {
                        Compare: comparePrimitives,
                    }))), (map_2((obj_2) => getEnumName(type$0027_1, obj_2), array_1))), (option_3 = (option_2 = SchemaModule_Annotator__Enum_Z721C83C5(annotator, name), (bind((r_1) => r_1.Default, option_2))), (defaultArgWith(option_3, () => {
                        if (options.StubDefaultValues) {
                            const arg0_12 = SchemaModule_stub(customRules, ti);
                            return arg0_12;
                        }
                        else {
                            return void 0;
                        }
                    })))));
                    cache.set(name, schema_4);
                    return new FSharpResult$2(0, schema_4);
                }
                case 16: {
                    const patternInput_3 = ti.fields[0]();
                    return genRecord(SchemaModule_nameFromTypeInfo(ti))((array_3 = (map_2((fi) => [fi.FieldName, fi.FieldType], patternInput_3[0])), (ofArray_1(array_3))));
                }
                case 17: {
                    return genRecord(SchemaModule_nameFromTypeInfo(ti))((array_5 = (array_4 = ti.fields[0](), (mapIndexed((idx, ti_2) => {
                        let arg10, clo1;
                        return [(arg10 = ((idx + 1) | 0), (clo1 = toText(printf("Item%d")), clo1(arg10))), ti_2];
                    }, array_4))), (ofArray_1(array_5))));
                }
                case 18: {
                    const result_4 = gen(ti.fields[0]());
                    return Result_Bind((someSchema) => {
                        const arg0_14 = new Schema(12, [new Schema(0), someSchema]);
                        return new FSharpResult$2(0, arg0_14);
                    }, result_4);
                }
                case 19: {
                    const patternInput_4 = ti.fields[0]();
                    let result_6;
                    let result_5;
                    let list;
                    list = ofArray_1(patternInput_4[0]);
                    result_5 = SchemaModule_traverse((case$) => {
                        let array_8, array_7;
                        return genRecord((SchemaModule_nameFromType(patternInput_4[1]) + ".") + case$.CaseName)((array_8 = (array_7 = zip(getUnionCaseFields(case$.Info), case$.CaseTypes), (map_2((tupledArg) => [name_3(tupledArg[0]), tupledArg[1]], array_7))), (ofArray_1(array_8))));
                    }, list);
                    result_6 = Result_Map((arg) => {
                        let arg0_15;
                        arg0_15 = Array.from(arg);
                        return new Schema(12, arg0_15);
                    }, result_5);
                    return Result_MapError((arg0_16) => (new SchemaError(0, arg0_16)), result_6);
                }
                case 20: {
                    return new FSharpResult$2(0, new Schema(5));
                }
                case 21: {
                    return new FSharpResult$2(0, new Schema(3));
                }
                case 22: {
                    return new FSharpResult$2(0, new Schema(7));
                }
                case 23: {
                    return new FSharpResult$2(0, new Schema(7));
                }
                case 24: {
                    return new FSharpResult$2(0, new Schema(7));
                }
                case 25: {
                    return new FSharpResult$2(0, new Schema(2));
                }
                case 26: {
                    const type$0027_4 = ti.fields[0]();
                    let matchValue_1;
                    matchValue_1 = tryFind((t_1) => equals(type$0027_4, t_1.InstanceType), customRules);
                    if (matchValue_1 == null) {
                        return new FSharpResult$2(1, new SchemaError(1, type$0027_4));
                    }
                    else {
                        const rule = matchValue_1;
                        ti_mut = createTypeInfo(rule.SurrogateType);
                        continue gen;
                    }
                }
                case 27: {
                    return new FSharpResult$2(1, new SchemaError(2, ti));
                }
            }
            break;
        }
    };
    const genRecord = (recordName) => ((fieldsInfo_1) => {
        let option_5, option_4;
        let matchValue_2;
        let outArg = null;
        matchValue_2 = [tryGetValue(cache, recordName, new FSharpRef(() => outArg, (v) => {
            outArg = v;
        })), outArg];
        if (matchValue_2[0]) {
            return new FSharpResult$2(0, matchValue_2[1]);
        }
        else {
            const fields = [];
            const schema_6 = new Schema(8, new RecordSchema(recordName, (option_5 = (option_4 = SchemaModule_Annotator__Record_Z721C83C5(annotator, recordName), (map_1((r_2) => r_2.Aliases, option_4))), (defaultArg(option_5, empty()))), fields));
            cache.set(recordName, schema_6);
            let result_9;
            let result_8;
            result_8 = SchemaModule_traverse((tupledArg_1) => {
                const fieldName = tupledArg_1[0];
                const typeInfo_1 = tupledArg_1[1];
                const result_7 = gen(typeInfo_1);
                return Result_Map((fieldSchema) => {
                    let defValue;
                    if (options.StubDefaultValues) {
                        let arg0_26;
                        const matchValue_3 = [typeInfo_1, SchemaModule_stub(customRules, typeInfo_1)];
                        let pattern_matching_result_1, f_11, props, json;
                        if (matchValue_3[0].tag === 34) {
                            if (matchValue_3[1].tag === 5) {
                                pattern_matching_result_1 = 0;
                                f_11 = matchValue_3[0].fields[0];
                                props = matchValue_3[1].fields[0];
                            }
                            else {
                                pattern_matching_result_1 = 1;
                                json = matchValue_3[1];
                            }
                        }
                        else {
                            pattern_matching_result_1 = 1;
                            json = matchValue_3[1];
                        }
                        switch (pattern_matching_result_1) {
                            case 0: {
                                let tuple;
                                let source;
                                source = toSeq(props);
                                tuple = head_3(source);
                                arg0_26 = tuple[1];
                                break;
                            }
                            case 1: {
                                arg0_26 = json;
                                break;
                            }
                        }
                        defValue = arg0_26;
                    }
                    else {
                        defValue = (void 0);
                    }
                    let matchValue_4;
                    matchValue_4 = SchemaModule_Annotator__Field(annotator, recordName, fieldName);
                    if (matchValue_4 == null) {
                        return new RecordField(fieldName, empty(), fieldSchema, defValue);
                    }
                    else {
                        const a = matchValue_4;
                        return new RecordField(fieldName, a.Aliases, fieldSchema, (defaultArg(a.Default, defValue)));
                    }
                }, result_7);
            }, fieldsInfo_1);
            result_9 = Result_Map((recordFields) => {
                addRangeInPlace(recordFields, fields);
                return schema_6;
            }, result_8);
            return Result_MapError((arg0_27) => (new SchemaError(0, arg0_27)), result_9);
        }
    });
    return gen(typeInfo);
}

export function SchemaModule_toString(schema) {
    const cache = new Map([]);
    const typeField = (typeName) => ["type", new Json(1, typeName)];
    const nameField = (name) => ["name", new Json(1, name)];
    const arrayField = (name_1, _arg1) => {
        let arg0_1, array_1;
        if ((!equalsWith(comparePrimitives, _arg1, null)) ? (_arg1.length === 0) : false) {
            return void 0;
        }
        else {
            const arg0_2 = [name_1, (arg0_1 = (array_1 = (map_2((arg0) => (new Json(1, arg0)), _arg1)), (ofArray_1(array_1))), (new Json(4, arg0_1)))];
            return arg0_2;
        }
    };
    const aliasesField = (aliases) => arrayField("aliases", (Array.from(aliases)));
    const defaultField = (option) => map_1((v) => ["default", v], option);
    const parse = (_arg2) => {
        let pattern_matching_result, schema_2, schema_3, schema_4;
        if (_arg2.tag === 0) {
            pattern_matching_result = 0;
        }
        else if (_arg2.tag === 1) {
            pattern_matching_result = 1;
        }
        else if (_arg2.tag === 2) {
            pattern_matching_result = 2;
        }
        else if (_arg2.tag === 3) {
            pattern_matching_result = 3;
        }
        else if (_arg2.tag === 4) {
            pattern_matching_result = 4;
        }
        else if (_arg2.tag === 5) {
            pattern_matching_result = 5;
        }
        else if (_arg2.tag === 6) {
            pattern_matching_result = 6;
        }
        else if (_arg2.tag === 7) {
            pattern_matching_result = 7;
        }
        else if (_arg2.tag === 10) {
            pattern_matching_result = 8;
            schema_2 = _arg2.fields[0];
        }
        else if (_arg2.tag === 11) {
            pattern_matching_result = 9;
            schema_3 = _arg2.fields[0];
        }
        else if (_arg2.tag === 9) {
            if (cache.has(_arg2.fields[0].Name)) {
                pattern_matching_result = 10;
                schema_4 = _arg2.fields[0];
            }
            else {
                pattern_matching_result = 11;
            }
        }
        else {
            pattern_matching_result = 11;
        }
        switch (pattern_matching_result) {
            case 0: {
                return new Json(3);
            }
            case 1: {
                return new Json(1, "boolean");
            }
            case 2: {
                return new Json(1, "int");
            }
            case 3: {
                return new Json(1, "long");
            }
            case 4: {
                return new Json(1, "float");
            }
            case 5: {
                return new Json(1, "double");
            }
            case 6: {
                return new Json(1, "bytes");
            }
            case 7: {
                return new Json(1, "string");
            }
            case 8: {
                let arg0_3;
                const elements = ofSeq(delay(() => append_1(singleton_1(typeField("array")), delay(() => append_1(singleton_1(["items", parse(schema_2.Items)]), delay(() => {
                    let option_1;
                    return option_1 = defaultField(schema_2.Default), (toArray(option_1));
                }))))));
                arg0_3 = ofList(elements);
                return new Json(5, arg0_3);
            }
            case 9: {
                let arg0_4;
                const elements_1 = ofSeq(delay(() => append_1(singleton_1(typeField("map")), delay(() => append_1(singleton_1(["values", parse(schema_3.Values)]), delay(() => {
                    let option_2;
                    return option_2 = defaultField(schema_3.Default), (toArray(option_2));
                }))))));
                arg0_4 = ofList(elements_1);
                return new Json(5, arg0_4);
            }
            case 10: {
                return new Json(1, schema_4.Name);
            }
            case 11: {
                let pattern_matching_result_1, schema_6, schema_7;
                if (_arg2.tag === 9) {
                    pattern_matching_result_1 = 0;
                    schema_6 = _arg2.fields[0];
                }
                else if (_arg2.tag === 8) {
                    if (cache.has(_arg2.fields[0].Name)) {
                        pattern_matching_result_1 = 1;
                        schema_7 = _arg2.fields[0];
                    }
                    else {
                        pattern_matching_result_1 = 2;
                    }
                }
                else {
                    pattern_matching_result_1 = 2;
                }
                switch (pattern_matching_result_1) {
                    case 0: {
                        cache.set(schema_6.Name, new Schema(9, schema_6));
                        let arg0_5;
                        const elements_2 = ofSeq(delay(() => append_1(singleton_1(typeField("enum")), delay(() => append_1(singleton_1(nameField(schema_6.Name)), delay(() => {
                            let option_3;
                            return append_1((option_3 = aliasesField(schema_6.Aliases), (toArray(option_3))), delay(() => {
                                let option_4;
                                return append_1((option_4 = arrayField("symbols", schema_6.Symbols), (toArray(option_4))), delay(() => {
                                    let option_5;
                                    return option_5 = defaultField(schema_6.Default), (toArray(option_5));
                                }));
                            }));
                        }))))));
                        arg0_5 = ofList(elements_2);
                        return new Json(5, arg0_5);
                    }
                    case 1: {
                        return new Json(1, schema_7.Name);
                    }
                    case 2: {
                        switch (_arg2.tag) {
                            case 8: {
                                const schema_8 = _arg2.fields[0];
                                cache.set(schema_8.Name, new Schema(8, schema_8));
                                let arg0_8;
                                const elements_4 = ofSeq(delay(() => append_1(singleton_1(typeField("record")), delay(() => append_1(singleton_1(nameField(schema_8.Name)), delay(() => {
                                    let option_6;
                                    return append_1((option_6 = aliasesField(schema_8.Aliases), (toArray(option_6))), delay(() => {
                                        let arg0_7;
                                        return singleton_1(["fields", (arg0_7 = ofSeq(delay(() => map_3((field) => {
                                            let arg0_6;
                                            const elements_3 = ofSeq(delay(() => append_1(singleton_1(nameField(field.Name)), delay(() => {
                                                let option_7;
                                                return append_1((option_7 = aliasesField(field.Aliases), (toArray(option_7))), delay(() => append_1(singleton_1(["type", parse(field.Type)]), delay(() => {
                                                    let option_8;
                                                    return option_8 = defaultField(field.Default), (toArray(option_8));
                                                }))));
                                            }))));
                                            arg0_6 = ofList(elements_3);
                                            return new Json(5, arg0_6);
                                        }, schema_8.Fields))), (new Json(4, arg0_7)))]);
                                    }));
                                }))))));
                                arg0_8 = ofList(elements_4);
                                return new Json(5, arg0_8);
                            }
                            case 12: {
                                let arg0_9;
                                let array_3;
                                array_3 = map_2(parse, _arg2.fields[0]);
                                arg0_9 = ofArray_1(array_3);
                                return new Json(4, arg0_9);
                            }
                            case 13: {
                                const schema_9 = _arg2.fields[0];
                                cache.set(schema_9.Name, new Schema(13, schema_9));
                                let arg0_10;
                                const elements_5 = ofSeq(delay(() => append_1(singleton_1(typeField("fixed")), delay(() => append_1(singleton_1(nameField(schema_9.Name)), delay(() => {
                                    let option_9;
                                    return append_1((option_9 = aliasesField(schema_9.Aliases), (toArray(option_9))), delay(() => singleton_1(["size", new Json(0, schema_9.Size)])));
                                }))))));
                                arg0_10 = ofList(elements_5);
                                return new Json(5, arg0_10);
                            }
                            default: {
                                const clo1 = toFail(printf("wrong case %A"));
                                return clo1(_arg2);
                            }
                        }
                    }
                }
            }
        }
    };
    const _arg1_1 = parse(schema);
    return SimpleJson_toString(_arg1_1);
}

